/***********************************************************
Tworld
***********************************************************/
var hostString="";

var DATA_VASP_ID=0;
var DATA_VAS_ID=1;
var DATA_USER_KEY=2;
var DATA_USER_LEVEL=3;
var DATA_USER_MDN=4;
var DATA_USER_NUM=5;
var DATA_FREE_COUNT=6;
var DATA_CASH_KEY=7;
var DATA_COUPON_COUNT=8;

function init(){
  this.initStage=ST_PRE;
  this.loginData=["https://nicasams.sktelecom.com:2552/icas/fc/LogOnSV","ID","PASSWORD","URL="+encodeURIComponent("http://www.tworld.co.kr/loginservlet.do?returnURL=&kind=&popup=&cmd=")];
  this.pattern=/\uc804\uc1a1\ub418\uc5c8\uc2b5\ub2c8\ub2e4/; 
  
  this.defaultHeaders={"User-Agent":"Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"};
  this.timer=Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
}
function process(aHttpChannel, aData) {
  switch(this.stage){
  case ST_PRE:
    this.loginTime=null;
    this.getHtml("http://www.tworld.co.kr/jsp/common/loginout/view/cm8_login_page.jsp");
    return false;
  case ST_PRE_RES:
    var fnd=aData.match(/SERVERIP\s+value=(\S+)>/);
    if(fnd){
      this.stage=ST_LOGIN;
      this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&SERVERIP="+encodeURIComponent(fnd[1]));
      return false;
    }
    break;
  case ST_LOGIN_RES:
    var fnd=aData.match(/url=(\S+)\'/);
    if(fnd){
      this.getHtml(fnd[1]);
      return false;
    }
    break;
  case ST_LOGIN_RES+1:
    this.getHtml("http://www.tworld.co.kr/normal.do?serviceId=S_ETC_0031&viewId=V_CENT0415");
    return false;    
  case ST_LOGIN_RES+2:
    var fnd=aData.match(/"ifr_body"\s+src="(\S+?)"/);
    if(fnd){
      this.getHtml(fnd[1]);
      return false;
    }
    break;
  case ST_LOGIN_RES+3:
    var fnd=aData.match(/tParam\'\s+value=\'(\S+)\'>/);    
    if(fnd){
      this.getHtml("http://message.tworld.co.kr/mpomr/13001/main.xcg?opcode=first","tParam="+fnd[1]+"&chkYn=Y");
      return false;
    }
    break;
  case ST_LOGIN_RES+4:
    var param=this.getForm(aData);
    if(param){
      var fnd=param.match(/user_key=(\S+?)&/);
      if(fnd){
        var dd=extract(fnd[1]);
        this.getHtml("http://message.tworld.co.kr/mpomr/13001/login.xcg?opcode=login&A8946B544391CECA6D62ED0061E2FC49="+encodeURIComponent(dd)+"&"+param,null,{"Referer":"http://message.tworld.co.kr/mpomr/13001/main.xcg?opcode=first"});
        return false;
      }
    }
    break;
  case ST_LOGIN_RES+5:
    var fnd=aData.match(/href="(\S+)"/);
    if(fnd){
      this.stage=ST_DATA;
      this.dataURL="http://message.tworld.co.kr/"+fnd[1]; // mpomr.xcg
    }
    break;  
  case ST_DATA_RES:    
    this.userData=[];
    var reg=[ /"vasid"[\S\s]*?=\s*?"(\S*?)"/,
              /"user_key"[\S\s]*?=\s*?"(\S*?)"/,
              /"user_level"[\S\s]*?=\s*?"(\S*?)"/,
              /"user_mdn"[\S\s]*?=\s*?"(\S*?)"/,
              /"user_num"[\S\s]*?=\s*?"(\S*?)"/,
              /"free_count"[\S\s]*?=\s*?"(\S*?)"/,
              /"cash_key"[\S\s]*?=\s*?"(\S*?)"/
        ];
    for(var i=0;i<reg.length;i++){
      fnd=aData.match(reg[i]);
      if(fnd){
        this.userData[i+DATA_VAS_ID]=fnd[1];
      }else{
        this.onError();
        return true;
      }
    }
    this.count=parseInt(this.userData[DATA_FREE_COUNT]);
    this.setSender(this.userData[DATA_USER_MDN]);
    
    fnd=aData.match(/"leftFrame"[\s\S]+?src="(\S+)"/);
    if(fnd){
      this.referer="http://message.tworld.co.kr"+fnd[1]; //leftmenu.xcg
      fnd=aData.match(/"mainFrame"[\s\S]+?src="(\S+)"/);
      if(fnd){
        this.mainFrame="http://message.tworld.co.kr"+fnd[1]; //hot_index.xcg
        fnd=aData.match(/"topf"[\s\S]+?src="(\S+)"/);
        if(fnd){
          this.getHtml("http://message.tworld.co.kr"+fnd[1]); //topmenu.xcg
          return false;
        }
      }
    }
    break;
  case ST_DATA_RES+1:
    this.getHtml(this.referer);  
    return false;
  case ST_DATA_RES+2:
//dout(aData);  
    this.getHtml(this.mainFrame);  
    return false;    
  case ST_DATA_RES+3:
    if(this.loginTime==null)this.loginTime=new Date().getTime();    
    this.stage=ST_DATA_RES;
    break;
//    this.stage=ST_SEND;
//    return true;    
  case ST_SEND:
    var delay=6000-(new Date().getTime()-this.loginTime);
    this.stage=ST_SEND_RES+2;         
    if(delay>0){
      this.timer.initWithCallback(this,
                                  6000,
                                  Components.interfaces.nsITimer.TYPE_ONE_SHOT);
      return true; 
    }
  case ST_SEND_RES+2:    
    this.stage=ST_SEND;
    break;
  case ST_SEND_RES+3:    
    this.post=this.getForm(aData,"sendForm");
    fnd=this.post.match(/AUTH_CERT=0/);
    if(fnd){
      if(this.userData[DATA_VAS_ID]=="13001"){
        this.getHtml("http://messageapp.tworld.co.kr:8001/mpomr/auth_mgr.fcgi?SEND_MDN="+this.userData[DATA_USER_MDN]);
      }else{
        this.getHtml("http://mprapp.nate.com:8001/mpomr/auth_mgr.fcgi?SEND_MDN="+this.userData[DATA_USER_MDN]);
      }
      return false;
    }
    this.stage=ST_SEND_RES+5;
  case ST_SEND_RES+4:
    if(this.stage==ST_SEND_RES+4){
      var rs=this.main.openAuthDialog();
      if(rs){
        this.post=this.post.replace("AUTH_NUM=&","AUTH_NUM="+encodeURIComponent(rs)+"&");
        this.stage=ST_SEND_RES+5;
      }else{
        ////////this.main.retry=RETRY_LIMIT;    
        ////////Send fail;
        this.main.msg=[];

        aData="";
        this.stage=ST_SEND_RES;
        break;
      }
    }
  case ST_SEND_RES+5:  
    if(this.stage==ST_SEND_RES+5){  
      this.stage=ST_SEND_RES;
      var ref={"Referer":"http://messageapp.tworld.co.kr:8001/mpomr/sms_upload_free.fcgi"};
      this.getHtml("http://messageapp.tworld.co.kr:8001/mpomr/sms_send_free.fcgi",this.post,ref);
      return true;
    }
  }
  return this.baseProcess(aHttpChannel, aData);
}
function onSend(sender,receiver,msg){
  this.stage=ST_SEND_RES+2;
  this.userData[DATA_VASP_ID]=10000;

  var post="TYPE=1&DELIVERY_TIME="
            +"&VAS_ID="+this.userData[DATA_VAS_ID]
            +"&USER_LEVEL="+this.userData[DATA_USER_LEVEL]
            +"&USER_NUM="+this.userData[DATA_USER_NUM]
            +"&FREE_COUNT="+this.userData[DATA_FREE_COUNT]
            +"&TITLE="
            +"&SEND_MDN="+this.userData[DATA_USER_MDN]
            +"&RECV_MDN="+receiver
            +"&TEXT="+msg
            +"&USER_KEY="+this.userData[DATA_USER_KEY]
            +"&BGI_CID="
            +"&BGM_CID="
            +"&GALLERY_CID="
            +"&BGI_PRICE="
            +"&BGM_PRICE="
            +"&GALLERY_PRICE="
            +"IMG_CID=&"
            +"IMG_URL=&"
            +"SVC_TYPE=&"             
            +"&VASP_ID="+this.userData[DATA_VASP_ID]
            +"&USER_ID="+this.userData[DATA_USER_KEY]
            +"&VAS_CASH_YN="+"N"
            +"&CASH_KEY="+this.userData[DATA_CASH_KEY]
            +"&PHOTO_CHAR_URL="
            +"&UP_PATH="
            +"&JPG_PATH="
            +"&TIME1="
            +"&JPGFILE00="
            +"&JPGFILE01="
            +"&JPGFILE02="
            +"&PHOTO_DECO="
            +"&CALL_MDN="+sender;
  //main.setState(nsILightSMS.ST_SEND,nsILightSMS.RS_TRY);
  this.getHtml("http://messageapp.tworld.co.kr:8001/mpomr/sms_upload_free.fcgi",post,{"Referer":this.referer});
  return false;  
}
function notify(aTimer){
  if(!this.process(null,""))++this.stage;
}
function getCount(aData){
  return this.count;
}
///////////////////////////////////////////////////////

function rand(idx)
{
	if (idx == 1)
	{
		tmp = Math.random() * 20;
	}
	else 
	{
		tmp = Math.random() * 20;
	}
	return parseInt(tmp);
}//rand()


var g_ctime= 0;

var g_Min = 0;
var FIND1=1;
var FIND2=3;
var FIND3=9;
var DEFAULT=31;

function now (key)
{
	var dnow = new Date();

	//var min = now.getMinutes();
	//var hour = now.getHours();

	/* GET GMT */
	min = dnow.getUTCMinutes();
	hour = dnow.getUTCHours(); 
	//alert (String.fromCharCode(min+65));

	//temp = (hour * 100 + min ) % 128;
	temp = (hour * 100 + min ) % key.length;

	chr = key.charAt(temp);
	//alert ("chr = " + chr); 

	g_Min = min + DEFAULT;

	//g_ctime = escape(String.fromCharCode(hour+65))+ escape(String.fromCharCode(min+65));

	g_ctime = String.fromCharCode(hour+65)+ String.fromCharCode(min+65);

	return chr;
}

function find_int(key, idx)
{
	var i;
	var temp = 0;
	for(i=g_Min; i< key.length; i++)
	{
		temp2 = isFinite (key.charAt(i));
		if(temp2)
		{
			temp++;
			//alert ("temp = " + temp + ", idx = " + idx);
			if (temp == idx)
			{
				//	alert ("g_Min BEFORE == > " + g_Min);
				g_Min = i+1;
				//	alert ("g_Min AFTER == > " + g_Min);
				//return key.charAt(i);
				return g_Min;
			}
		}
	}

	return 7;
}

function extract(key)
{
	var str = "";
	idx1 = rand(1);
	idx2 = rand(2);
	sep1 = 'C';
	sep2 = 'K';

	if (key.length <30)
	{
		str = "USER_KEYisNULL";
	}
	else
	{
		//str = idx1+ sep1 + idx2 + sep2 + key.charAt(idx1+31)+ key.substring(10).charAt(idx2) + postfix(key) + idx1 + now(key);
		str = postfix(key) + g_ctime;
	}
	return str;
}

function postfix(key)
{
	var str="";
	chr = now(key);

	idx1 = find_int(key, FIND1)
		idx2 = find_int(key, FIND2);
	idx3 = find_int(key, FIND3);

	//alert ("idx1 = " + idx1 + ", idx2 = " + idx2 + ", idx3 = " + idx3);
	for (i=0 ; i < 128 ; i++)
	{
		tmp = (Math.random() * 100) % 25 + 65;
		if (i == idx1 || i == idx2 || i == idx3)
		{
			str += chr;
		}
		else
		{
			str += String.fromCharCode(tmp);
		}
	}

	return str;
}

